; wrap the tripod stuff for MIDI input
; run as, e.g. 
; csound -M 0 -m 38 -d -odac tripod-midi.orc midi.sco

; controls the coarse pitch of the keyboard
giregister	=	4

gikbdToe	ftgen	0, 0, 32, -2, \
		2, 2, 3, 3, 3, 4, 4, 5, 5, 6, 6, 6, \
		7, 7, 8, 8, 8, 9, 9, 9, 11, 11, 11, 11

gikbdShift	ftgen	0, 0, 32, -2, \
		-1, 0, -1, 0, 1, -1, 0, -1, 0, -1, 0, 1, \
		-1, 0, -1, 0, 1, -1, 0, 1, -2, -1, 0, 1

gicompactToe	ftgen	0, 0, 64, -2, \
		1, 2, 2, 3, 3, \
		4, 4, 5, 5, 6, 6, 7, \
		7, 8, 8, 9, 9, \
		11, 11, 12, 12, 13, 13, 14, \
		14, 15, 15, 16, 16, \
		17, 17, 18, 18, 19, 19, 19, \
		21, 22, 22, 23, 23, \
		24, 24, 25, 25, 26, 26, 27

gicompactShift	ftgen	0, 0, 64, -2, \
		0, -1, 0, -1, 0, \
		-1, 0, -1, 0, -1, 0, -1, \
		0, -1, 0, -1, 0, \
		-1, 0, -1, 0, -1, 0, -1, \
		0, -1, 0, -1, 0, \
		-1, 0, -1, 0, -1, 0, 1, \
		0, -1, 0, -1, 0, \
		-1, 0, -1, 0, -1, 0, -1

#include "common.headers"
#include "tripod.tuning"
#include "common.instruments"

#define	MIDIWrapper(stub) #
	instr	$stub.MIDI
imidipitch	init	0
imidivel	init	0
imidictl1	init	0
	midinoteonkey	imidipitch, imidivel
	midicontrolchange 1, imidictl1, 0, 1

idur	init	60
ivel	init	64 + imidivel/3
ikey	init	imidipitch
itimbre	init	imidictl1
ienvelope	init	0.1

	cggoto	(ikey != 36), notlowest
giregister	=     	giregister - 1
	print	giregister
	goto	end

notlowest:
	cggoto	(ikey != 84), note
giregister	=     	giregister + 1
	print	giregister
	goto	end

note:
ipitchClass	=	ikey%24
ioctave	=	int(ikey/24) + giregister - 2
itoes	table           ipitchClass, gikbdToe
ishift	table           ipitchClass, gikbdShift
inote	=	ioctave + itoes/10
ifreq	R2Tuning	inote, ishift

	print	ivel
	print	inote
	print	ishift
	print	itimbre
	print	ienvelope

kamp, ktimbre1, ktimbre2, knoise  MIDIEnvs  ivel, idur, itimbre, ienvelope

aout	$stub.Timbre	kamp, ifreq, ktimbre1, ktimbre2, knoise

; make the output moist
; and center panned
aout	SOut	aout, 0, 0.3, gi_dry
end:
	endin
#

$MIDIWrapper(Harmonic)

#define	CompactWrapper(stub) #
	instr	$stub.Compact
imidipitch	init	0
imidivel	init	0
imidictl1	init	0
	midinoteonkey	imidipitch, imidivel
	midicontrolchange 1, imidictl1, 0, 1

idur	init	60
ivel	init	64 + imidivel/3
ikey	init	imidipitch - 36
itimbre	init	imidictl1
ienvelope	init	0.3

	cggoto	(ikey != 0), notlowest
giregister	=     	giregister - 1
	print	giregister
	goto	end

notlowest:
	cggoto	(ikey != 48), note
giregister	=     	giregister + 1
	print	giregister
	goto	end

note:
ipitchClass	=	ikey%48
ioctave	=	giregister-1
itoes	table           ipitchClass, gicompactToe
ishift	table           ipitchClass, gicompactShift
inote	=	ioctave + itoes/10
ifreq	R2Tuning	inote, ishift

	print	ivel
	print	inote
	print	ishift
	print	itimbre

kamp, ktimbre1, ktimbre2, knoise  MIDIEnvs  ivel, idur, itimbre, ienvelope

aout	$stub.Timbre	kamp, ifreq, ktimbre1, ktimbre2, knoise

; make the output moist
; and center panned
aout	SOut	aout, 0, 0.3, gi_dry
end:
	endin
#

$CompactWrapper(Harmonic)

; based on the example in The Csound Book Chapter 19
	instr	CompactClarinet
imidipitch	init	0
imidivel	init	0
	midinoteonkey	imidipitch, imidivel
kmodulation	midictrl	1, 0, 0.2

ikey	init	imidipitch - 36
	cggoto	(ikey != 0), notlowest
giregister	=	giregister - 1
	print	giregister
	goto	end

notlowest:
	cggoto	(ikey != 48), note
giregister	=	giregister + 1
	print	giregister
	goto	end

note:
ipitchClass	=	ikey%48
ioctave	=	giregister-1
itoes	table	ipitchClass, gicompactToe
ishift	table	ipitchClass, gicompactShift
inote	=	ioctave + itoes/10
ifqc	R2Tuning	inote, ishift

;	ENVELOPE FROM PERRY COOKE'S CLARINET
imax_press	=	imidivel/300 + 0.7
; note: insanely values make a good percussive sound
kpressure	linsegr	0, .005, imax_press, 60 - .015, imax_press, .01, 0

; looks more like tremolo
kvibr	linseg	0, .1, 0, .9, 1, 60-1, 1   ; VIBRATO ENVELOPE
kvibr	oscil	kmodulation*kvibr, 5, gi_sine_wave

aamp	interp	imidivel*50, 0, 1
aemboff	interp	0.2, 0, 1
apress	interp	kpressure + kvibr, 0, 0
aout	ClarinetTimbre	aamp, ifqc, apress, aemboff

; make the output moist
; and center panned
aout	SOut	aout, 0, 0.3, gi_dry

end:
	endin



; permanently running instrument for effects and the like
	instr	98

areverbl	zar	gi_reverb
areverbr	zar	gi_reverb+1

adryl	zar	gi_dry
adryr	zar	gi_dry+1
; delay the dry outputs to catch up with reverb
adryl	delay	adryl, 0.045
adryr	delay	adryr, 0.045

aoutl, aoutr	reverbsc	areverbl, areverbr, 0.8, 5000
	zacl	0, 4
	outs	aoutl+adryl, aoutr+adryr

; Choose the MIDI instrument(s) here
	massign	1, "CompactClarinet"

	endin

; vim: tabstop=16 listchars=tab\:>\ ,trail\:. :
